<!doctype html>
<html       lang="en"      dir="ltr">
  <head>
    <meta name="google-signin-client-id" content="721724668570-nbkv1cfusk7kk4eni4pjvepaus73b13t.apps.googleusercontent.com">
    <meta name="google-signin-scope" content="profile email">
    <meta property="og:site_name" content="Google Developers">
    <meta property="og:type" content="website">
    
          <meta name="theme-color" content="#009688">
    
    <meta charset="utf-8">
    <meta content="IE=Edge" http-equiv="X-UA-Compatible">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="manifest" href="/_pwa/developers/manifest.json"
          crossorigin="use-credentials">
    <link rel="preconnect" href="//www.gstatic.com" crossorigin>
    <link rel="preconnect" href="//fonts.gstatic.com" crossorigin>
    <link rel="preconnect" href="//fonts.googleapis.com" crossorigin>
    <link rel="stylesheet" href="//fonts.googleapis.com/css?family=Google+Sans:400,500|Roboto:400,400italic,500,500italic,700,700italic|Roboto+Mono:400,500,700|Material+Icons">
        <link rel="stylesheet" href="https://www.gstatic.com/devrel-devsite/prod/v84899ba5ac366dd19b845bb4579ea9262ac5ac73d5db61a8fa440a5f2fc65a26/developers/css/app.css">
    <noscript>
      <link rel="stylesheet" href="https://www.gstatic.com/devrel-devsite/prod/v84899ba5ac366dd19b845bb4579ea9262ac5ac73d5db61a8fa440a5f2fc65a26/developers/css/ce_bundle.css">
    </noscript>
    <link rel="shortcut icon" href="https://www.gstatic.com/devrel-devsite/prod/v84899ba5ac366dd19b845bb4579ea9262ac5ac73d5db61a8fa440a5f2fc65a26/developers/images/favicon.png">
    <link rel="apple-touch-icon" href="https://www.gstatic.com/devrel-devsite/prod/v84899ba5ac366dd19b845bb4579ea9262ac5ac73d5db61a8fa440a5f2fc65a26/developers/images/touchicon-180.png"><link rel="canonical" href="https://developers.google.com/identity/protocols/oauth2/native-app?hl=sv"><link rel="search" type="application/opensearchdescription+xml"
            title="Google Developers" href="https://developers.google.com/s/opensearch.xml">      
<title>OAuth 2.0 for Mobile & Desktop Apps &nbsp;|&nbsp; Google Identity Platform</title>

<meta property="og:title" content="OAuth 2.0 for Mobile & Desktop Apps &nbsp;|&nbsp; Google Identity Platform">


  <meta property="og:url" content="https://developers.google.com/identity/protocols/oauth2/native-app?hl=sv">

  <meta property="og:image" content="https://www.gstatic.com/devrel-devsite/prod/v84899ba5ac366dd19b845bb4579ea9262ac5ac73d5db61a8fa440a5f2fc65a26/developers/images/opengraph/teal.png">
  <meta property="og:image:secure_url" content="https://www.gstatic.com/devrel-devsite/prod/v84899ba5ac366dd19b845bb4579ea9262ac5ac73d5db61a8fa440a5f2fc65a26/developers/images/opengraph/teal.png">
  <meta property="og:image:width" content="1200">
  <meta property="og:image:height" content="675">
  <meta property="og:locale" content="en">
  <meta name="twitter:card" content="summary_large_image">


  <script type="application/ld+json">
  {
    "@context": "https://schema.org",
    "@type": "BreadcrumbList",
    "itemListElement": [{
      "@type": "ListItem",
      "position": 1,
      "name": "Google Identity Platform",
      "item": "https://developers.google.com/identity"
    },{
      "@type": "ListItem",
      "position": 2,
      "name": "OAuth 2.0 for Mobile &amp; Desktop Apps",
      "item": "https://developers.google.com/identity/protocols/oauth2/native-app"
    }]
  }
  </script>



  
    
    
    
    
  

    </head>
  <body type="article"
        theme="teal"
        class=""
        
        layout="docs"
                        pending>
    <devsite-progress type="indeterminate" id="app-progress"></devsite-progress>
    <section class="devsite-wrapper"><devsite-header>
      







<div class="devsite-header--inner">
  <div class="devsite-top-logo-row-wrapper-wrapper">
    <div class="devsite-top-logo-row-wrapper">
      <div class="devsite-top-logo-row">
        <button type="button" id="devsite-hamburger-menu"
          class="devsite-header-icon-button button-flat material-icons gc-analytics-event"
          data-category="Site-Wide Custom Events"
          data-label="Navigation menu button"
          visually-hidden
          aria-label="Open menu">
        </button>
        <div class="devsite-product-name-wrapper">
      
  
  <span class="devsite-product-name">
    <ul class="devsite-breadcrumb-list">
    <li class="devsite-breadcrumb-item
             devsite-has-google-wordmark">
                                  <a href="/identity"              class="devsite-breadcrumb-link gc-analytics-event"
              data-category="Site-Wide Custom Events"
              data-label="Upper Header"
              data-value="1"
          >
              <svg class="devsite-google-wordmark"
       xmlns="http://www.w3.org/2000/svg"
       viewBox="0 0 148 48">
    <title>Google</title>
    <path class="devsite-google-wordmark-svg-path" d="M19.58,37.65c-9.87,0-18.17-8.04-18.17-17.91c0-9.87,8.3-17.91,18.17-17.91c5.46,0,9.35,2.14,12.27,4.94l-3.45,3.45c-2.1-1.97-4.93-3.49-8.82-3.49c-7.21,0-12.84,5.81-12.84,13.02c0,7.21,5.64,13.02,12.84,13.02c4.67,0,7.34-1.88,9.04-3.58c1.4-1.4,2.32-3.41,2.66-6.16H19.58v-4.89h16.47c0.18,0.87,0.26,1.92,0.26,3.06c0,3.67-1.01,8.21-4.24,11.44C28.93,35.9,24.91,37.65,19.58,37.65z M61.78,26.12c0,6.64-5.1,11.53-11.36,11.53s-11.36-4.89-11.36-11.53c0-6.68,5.1-11.53,11.36-11.53S61.78,19.43,61.78,26.12z M56.8,26.12c0-4.15-2.96-6.99-6.39-6.99c-3.43,0-6.39,2.84-6.39,6.99c0,4.11,2.96,6.99,6.39,6.99C53.84,33.11,56.8,30.22,56.8,26.12z M87.25,26.12c0,6.64-5.1,11.53-11.36,11.53c-6.26,0-11.36-4.89-11.36-11.53c0-6.68,5.1-11.53,11.36-11.53C82.15,14.59,87.25,19.43,87.25,26.12zM82.28,26.12c0-4.15-2.96-6.99-6.39-6.99c-3.43,0-6.39,2.84-6.39,6.99c0,4.11,2.96,6.99,6.39,6.99C79.32,33.11,82.28,30.22,82.28,26.12z M112.09,15.29v20.7c0,8.52-5.02,12.01-10.96,12.01c-5.59,0-8.95-3.76-10.22-6.81l4.41-1.83c0.79,1.88,2.71,4.1,5.81,4.1c3.8,0,6.16-2.36,6.16-6.77v-1.66h-0.18c-1.14,1.4-3.32,2.62-6.07,2.62c-5.76,0-11.05-5.02-11.05-11.49c0-6.51,5.28-11.57,11.05-11.57c2.75,0,4.93,1.22,6.07,2.58h0.18v-1.88H112.09z M107.64,26.16c0-4.06-2.71-7.03-6.16-7.03c-3.49,0-6.42,2.97-6.42,7.03c0,4.02,2.93,6.94,6.42,6.94C104.93,33.11,107.64,30.18,107.64,26.16z M120.97,3.06v33.89h-5.07V3.06H120.97z M140.89,29.92l3.93,2.62c-1.27,1.88-4.32,5.11-9.61,5.11c-6.55,0-11.28-5.07-11.28-11.53c0-6.86,4.77-11.53,10.71-11.53c5.98,0,8.91,4.76,9.87,7.34l0.52,1.31l-15.42,6.38c1.18,2.31,3.01,3.49,5.59,3.49C137.79,33.11,139.58,31.84,140.89,29.92zM128.79,25.77l10.31-4.28c-0.57-1.44-2.27-2.45-4.28-2.45C132.24,19.04,128.66,21.31,128.79,25.77z"/>
  </svg>Identity Platform        
  </a>
              </li>
  </ul>
  </span>
</div>
        <div class="devsite-top-logo-row-middle">
          <div class="devsite-header-upper-tabs">
                       </div>
          <devsite-search
    enable-signin    enable-search    enable-suggestions
      enable-query-completion        project-name="Google Identity Platform"    tenant-name="Google Developers"    project-scope="/identity"    url-scoped="https://developers.google.com/s/results/identity"        >
  <form class="devsite-search-form" action="https://developers.google.com/s/results" method="GET">
    <div class="devsite-search-container">
      <div class="devsite-searchbox">
                <input placeholder="Sök"
          type="text"
          class="devsite-search-field devsite-search-query"
          name="q"
          value=""
          autocomplete="off"
                    aria-label="Sökruta">
        <div class="devsite-search-image material-icons" aria-hidden="true"></div>
      </div>
      <button type="button"
              search-open
              class="devsite-search-button devsite-header-icon-button button-flat material-icons"
              aria-label="Open search box"></button>
    </div>
  </form>
  <button type="button"
          search-close
          class="devsite-search-button devsite-header-icon-button button-flat material-icons"
          aria-label="Close search box"></button>
</devsite-search>

        </div>

        
        <devsite-language-selector>
  <devsite-select class="devsite-language-selector-menu">
    <select class="devsite-language-selector-select"
            name="language"
            track-name="click"
            track-type="languageSelector">
                <option>Language</option>
              <option value="id"
              track-metadata-original-language="sv"
              track-metadata-selected-language="id"
              track-name="changed"
              track-type="languageSelector"
            >
        Bahasa Indonesia
      </option>
          <option value="de"
              track-metadata-original-language="sv"
              track-metadata-selected-language="de"
              track-name="changed"
              track-type="languageSelector"
            >
        Deutsch
      </option>
          <option value="en"
              track-metadata-original-language="sv"
              track-metadata-selected-language="en"
              track-name="changed"
              track-type="languageSelector"
            >
        English
      </option>
          <option value="es"
              track-metadata-original-language="sv"
              track-metadata-selected-language="es"
              track-name="changed"
              track-type="languageSelector"
            >
        Español
      </option>
          <option value="fr"
              track-metadata-original-language="sv"
              track-metadata-selected-language="fr"
              track-name="changed"
              track-type="languageSelector"
            >
        Français
      </option>
          <option value="pt_br"
              track-metadata-original-language="sv"
              track-metadata-selected-language="pt_br"
              track-name="changed"
              track-type="languageSelector"
            >
        Português – Brasil
      </option>
          <option value="sv"
              track-metadata-original-language="sv"
              track-metadata-selected-language="sv"
              track-name="changed"
              track-type="languageSelector"
            >
        Svenska
      </option>
          <option value="ru"
              track-metadata-original-language="sv"
              track-metadata-selected-language="ru"
              track-name="changed"
              track-type="languageSelector"
            >
        Русский
      </option>
          <option value="zh_cn"
              track-metadata-original-language="sv"
              track-metadata-selected-language="zh_cn"
              track-name="changed"
              track-type="languageSelector"
            >
        中文 – 简体
      </option>
          <option value="ja"
              track-metadata-original-language="sv"
              track-metadata-selected-language="ja"
              track-name="changed"
              track-type="languageSelector"
            >
        日本語
      </option>
          <option value="ko"
              track-metadata-original-language="sv"
              track-metadata-selected-language="ko"
              track-name="changed"
              track-type="languageSelector"
            >
        한국어
      </option>
        </select>
  </devsite-select>
</devsite-language-selector>


        
                                      <devsite-user                                                 ></devsite-user>
                         </div>    </div>  </div>
  <div class="devsite-collapsible-section
    ">
    <div class="devsite-header-background">
                                  <div class="devsite-doc-set-nav-row">
                                                      <devsite-tabs class="lower-tabs">
    <div class="devsite-tabs-wrapper">
                        <tab  >
            <a href="/identity"
   class="gc-analytics-event"
   track-type="globalNav"
   track-metadata-position="nav"
   track-metadata-eventdetail="nav"
   track-name="hem"
           data-category="Site-Wide Custom Events"
        data-label="Tab: Hem"
   >
  Hem
</a>

          </tab>
                                <tab  active>
            <a href="/identity/choose-auth"
   class="gc-analytics-event"
   track-type="globalNav"
   track-metadata-position="nav"
   track-metadata-eventdetail="nav"
   track-name="guider"
   aria-label="Guider, selected"         data-category="Site-Wide Custom Events"
        data-label="Tab: Guider"
   >
  Guider
</a>

          </tab>
                  </div>
  </devsite-tabs>


                            </div>
          </div>  </div></div>

  </devsite-header>      <devsite-book-nav scrollbars >
                  





<nav class="devsite-book-nav devsite-nav nocontent">
  <div class="devsite-mobile-header">
    <button type="button"
            id="devsite-close-nav"
            class="devsite-header-icon-button button-flat material-icons gc-analytics-event"
            data-category="Site-Wide Custom Events"
            data-label="Close navigation"
            aria-label="Close navigation">
    </button>
    <div class="devsite-product-name-wrapper">
      
          <span class="devsite-product-name">
        <ul class="devsite-breadcrumb-list">
    <li class="devsite-breadcrumb-item
             devsite-has-google-wordmark">
                                  <a href="/identity"              class="devsite-breadcrumb-link gc-analytics-event"
              data-category="Site-Wide Custom Events"
              data-label="Upper Header"
              data-value="1"
          >
              <svg class="devsite-google-wordmark"
       xmlns="http://www.w3.org/2000/svg"
       viewBox="0 0 148 48">
    <title>Google</title>
    <path class="devsite-google-wordmark-svg-path" d="M19.58,37.65c-9.87,0-18.17-8.04-18.17-17.91c0-9.87,8.3-17.91,18.17-17.91c5.46,0,9.35,2.14,12.27,4.94l-3.45,3.45c-2.1-1.97-4.93-3.49-8.82-3.49c-7.21,0-12.84,5.81-12.84,13.02c0,7.21,5.64,13.02,12.84,13.02c4.67,0,7.34-1.88,9.04-3.58c1.4-1.4,2.32-3.41,2.66-6.16H19.58v-4.89h16.47c0.18,0.87,0.26,1.92,0.26,3.06c0,3.67-1.01,8.21-4.24,11.44C28.93,35.9,24.91,37.65,19.58,37.65z M61.78,26.12c0,6.64-5.1,11.53-11.36,11.53s-11.36-4.89-11.36-11.53c0-6.68,5.1-11.53,11.36-11.53S61.78,19.43,61.78,26.12z M56.8,26.12c0-4.15-2.96-6.99-6.39-6.99c-3.43,0-6.39,2.84-6.39,6.99c0,4.11,2.96,6.99,6.39,6.99C53.84,33.11,56.8,30.22,56.8,26.12z M87.25,26.12c0,6.64-5.1,11.53-11.36,11.53c-6.26,0-11.36-4.89-11.36-11.53c0-6.68,5.1-11.53,11.36-11.53C82.15,14.59,87.25,19.43,87.25,26.12zM82.28,26.12c0-4.15-2.96-6.99-6.39-6.99c-3.43,0-6.39,2.84-6.39,6.99c0,4.11,2.96,6.99,6.39,6.99C79.32,33.11,82.28,30.22,82.28,26.12z M112.09,15.29v20.7c0,8.52-5.02,12.01-10.96,12.01c-5.59,0-8.95-3.76-10.22-6.81l4.41-1.83c0.79,1.88,2.71,4.1,5.81,4.1c3.8,0,6.16-2.36,6.16-6.77v-1.66h-0.18c-1.14,1.4-3.32,2.62-6.07,2.62c-5.76,0-11.05-5.02-11.05-11.49c0-6.51,5.28-11.57,11.05-11.57c2.75,0,4.93,1.22,6.07,2.58h0.18v-1.88H112.09z M107.64,26.16c0-4.06-2.71-7.03-6.16-7.03c-3.49,0-6.42,2.97-6.42,7.03c0,4.02,2.93,6.94,6.42,6.94C104.93,33.11,107.64,30.18,107.64,26.16z M120.97,3.06v33.89h-5.07V3.06H120.97z M140.89,29.92l3.93,2.62c-1.27,1.88-4.32,5.11-9.61,5.11c-6.55,0-11.28-5.07-11.28-11.53c0-6.86,4.77-11.53,10.71-11.53c5.98,0,8.91,4.76,9.87,7.34l0.52,1.31l-15.42,6.38c1.18,2.31,3.01,3.49,5.59,3.49C137.79,33.11,139.58,31.84,140.89,29.92zM128.79,25.77l10.31-4.28c-0.57-1.44-2.27-2.45-4.28-2.45C132.24,19.04,128.66,21.31,128.79,25.77z"/>
  </svg>Identity Platform        
  </a>
              </li>
  </ul>
      </span>
    
</div>  </div>

  <div class="devsite-book-nav-wrapper">
    <div class="devsite-mobile-nav-top">
              <ul class="devsite-nav-list">
                      <li class="devsite-nav-item">
    <a href="/identity"
           class="devsite-nav-title gc-analytics-event
                            "
    
         data-category="Site-Wide Custom Events"
     data-label="Responsive Tab: Hem"
     track-type="navMenu"
     track-metadata-eventDetail="globalMenu"
     track-metadata-position="nav"
     track-name="hem">
      <span class="devsite-nav-text" tooltip >
      Hem
   </span>
        </a>
  </li>

                      <li class="devsite-nav-item">
    <a href="/identity/choose-auth"
           class="devsite-nav-title gc-analytics-event
              devsite-nav-has-children              devsite-nav-active"
    
         data-category="Site-Wide Custom Events"
     data-label="Responsive Tab: Guider"
     track-type="navMenu"
     track-metadata-eventDetail="globalMenu"
     track-metadata-position="nav"
     track-name="guider">
      <span class="devsite-nav-text" tooltip >
      Guider
   </span>
        <span class="devsite-nav-icon material-icons" data-icon="forward"
          >
    </span>
        </a>
  </li>

                    
                  </ul>
          </div>
          <div class="devsite-mobile-nav-bottom">
                            <ul class="devsite-nav-list" menu="_book">
            <li class="devsite-nav-item"><a href="/identity/choose-auth"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Compare Auth Options</span></a></li>
  <li class="devsite-nav-item           devsite-nav-heading"><div class="devsite-nav-title devsite-nav-title-no-path"><span class="devsite-nav-text" tooltip>Google Sign-In</span></div><ul class="devsite-nav-section"><li class="devsite-nav-item"><a href="/identity/sign-in/android"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Android</span></a></li><li class="devsite-nav-item"><a href="/identity/sign-in/ios"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>iOS</span></a></li><li class="devsite-nav-item"><a href="/identity/sign-in/web"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Websites</span></a></li><li class="devsite-nav-item"><a href="/identity/sign-in/devices"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>TVs &amp; Devices</span></a></li><li class="devsite-nav-item"><a href="/identity/branding-guidelines"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Branding Guidelines</span></a></li></ul></li>
  <li class="devsite-nav-item           devsite-nav-heading"><div class="devsite-nav-title devsite-nav-title-no-path"><span class="devsite-nav-text" tooltip>Smart Lock for Passwords</span></div><ul class="devsite-nav-section"><li class="devsite-nav-item"><a href="/identity/smartlock-passwords/android"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Android</span></a></li></ul></li>
  <li class="devsite-nav-item           devsite-nav-heading"><div class="devsite-nav-title devsite-nav-title-no-path"><span class="devsite-nav-text" tooltip>Firebase Authentication</span></div><ul class="devsite-nav-section"><li class="devsite-nav-item"><a href="https://firebase.google.com/docs/auth/"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Firebase Auth Overview</span></a></li></ul></li>
  <li class="devsite-nav-item           devsite-nav-heading"><div class="devsite-nav-title devsite-nav-title-no-path"><span class="devsite-nav-text" tooltip>Auth Protocols</span></div><ul class="devsite-nav-section"><li class="devsite-nav-item"><a href="/identity/protocols/oauth2"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>OAuth 2.0 Overview</span></a></li><li class="devsite-nav-item"><a href="/identity/protocols/oauth2/openid-connect"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>OpenID Connect</span></a></li><li class="devsite-nav-item"><a href="/identity/protocols/oauth2/web-server"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>OAuth 2.0 for Server-side Web Apps</span></a></li><li class="devsite-nav-item"><a href="/identity/protocols/oauth2/javascript-implicit-flow"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>OAuth 2.0 for JavaScript Web Apps</span></a></li><li class="devsite-nav-item"><a href="/identity/protocols/oauth2/native-app"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>OAuth 2.0 for Mobile &amp; Desktop Apps</span></a></li><li class="devsite-nav-item"><a href="/identity/protocols/oauth2/limited-input-device"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>OAuth 2.0 for TV &amp; Device Apps</span></a></li><li class="devsite-nav-item"><a href="/identity/protocols/oauth2/service-account"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>OAuth 2.0 for Service Accounts</span></a></li><li class="devsite-nav-item"><a href="/identity/protocols/oauth2/scopes"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>OAuth 2.0 API Scopes</span></a></li><li class="devsite-nav-item"><a href="/identity/protocols/oauth2/cross-client-identity"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Cross-client Identity</span></a></li><li class="devsite-nav-item"><a href="/identity/protocols/risc"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Cross-Account Protection (RISC)</span></a></li></ul></li>
  <li class="devsite-nav-item           devsite-nav-heading"><div class="devsite-nav-title devsite-nav-title-no-path"><span class="devsite-nav-text" tooltip>Identity for IT Applications</span></div><ul class="devsite-nav-section"><li class="devsite-nav-item"><a href="/identity/work/it-apps"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Google Sign-In with Work Accounts</span></a></li><li class="devsite-nav-item"><a href="/identity/work/it-mobile-apps"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Mobile App Best Practices</span></a></li></ul></li>
  <li class="devsite-nav-item           devsite-nav-heading"><div class="devsite-nav-title devsite-nav-title-no-path"><span class="devsite-nav-text" tooltip>Identity for SaaS Applications</span></div><ul class="devsite-nav-section"><li class="devsite-nav-item"><a href="/identity/work/saas-browser-apps"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Browser App Best Practices</span></a></li><li class="devsite-nav-item"><a href="/identity/work/saas-mobile-apps"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>Mobile App Best Practices</span></a></li></ul></li>
  <li class="devsite-nav-item           devsite-nav-heading"><div class="devsite-nav-title devsite-nav-title-no-path"><span class="devsite-nav-text" tooltip>Fast Identity Online Universal 2nd Factor</span></div><ul class="devsite-nav-section"><li class="devsite-nav-item"><a href="/identity/fido"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>FIDO Authentication</span></a></li><li class="devsite-nav-item"><a href="/identity/fido/android/native-apps"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>FIDO for Native Apps</span></a></li></ul></li>
  <li class="devsite-nav-item           devsite-nav-break"></li>
  <li class="devsite-nav-item"><a href="/terms"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>APIs Terms of Service</span></a></li>
  <li class="devsite-nav-item"><a href="/terms/api-services-user-data-policy"
     class="devsite-nav-title"
   ><span class="devsite-nav-text" tooltip>APIs User Data Policy</span></a></li>
          </ul>
                      </div>
      </div>
</nav>
              </devsite-book-nav>
      <section id="gc-wrapper">
        <main role="main" class="devsite-main-content"
            has-book-nav            has-toc>
          <devsite-toc class="devsite-nav"
            ></devsite-toc>
          <devsite-content>
                          

<article class="devsite-article">
  <article class="devsite-article-inner"><style>
        .code-var-color {
        color: #ec407a;
        font-weight: bold;
      }
        </style>        
    <div class="devsite-article-meta">
      <ul class="devsite-breadcrumb-list">
    <li class="devsite-breadcrumb-item
             ">
                    <a href="/"              class="devsite-breadcrumb-link gc-analytics-event"
              data-category="Site-Wide Custom Events"
              data-label="Breadcrumbs"
              data-value="1"
          >
            Hem
      
  </a>
        </li>
    <li class="devsite-breadcrumb-item
             ">
                <div class="devsite-breadcrumb-guillemet material-icons" aria-hidden="true"></div>
                    <a href="/products"              class="devsite-breadcrumb-link gc-analytics-event"
              data-category="Site-Wide Custom Events"
              data-label="Breadcrumbs"
              data-value="2"
          >
            Produkter
      
  </a>
        </li>
    <li class="devsite-breadcrumb-item
             ">
                <div class="devsite-breadcrumb-guillemet material-icons" aria-hidden="true"></div>
                    <a href="/identity"              class="devsite-breadcrumb-link gc-analytics-event"
              data-category="Site-Wide Custom Events"
              data-label="Breadcrumbs"
              data-value="3"
          >
            Google Identity Platform
      
  </a>
        </li>
    <li class="devsite-breadcrumb-item
             ">
                <div class="devsite-breadcrumb-guillemet material-icons" aria-hidden="true"></div>
                    <a href="/identity/choose-auth"              class="devsite-breadcrumb-link gc-analytics-event"
              data-category="Site-Wide Custom Events"
              data-label="Breadcrumbs"
              data-value="4"
          >
            Guider
      
  </a>
        </li>
  </ul>
               <devsite-page-rating position="header" selected-rating="0" hover-rating-star="0">
         </devsite-page-rating>
          </div>

              <h1 class="devsite-page-title">OAuth 2.0 for Mobile & Desktop Apps</h1>
    
    <devsite-toc class="devsite-nav" devsite-toc-embedded
                 >
    </devsite-toc>

    <div class="devsite-article-body clearfix
      ">

              

    

    














































































































































































    

    
    

    

    <aside class="note"><b>Note:</b> If you are new to OAuth 2.0, we recommend that you read the
      <a href="/identity/protocols/oauth2">OAuth 2.0 overview</a> before getting started. The
      overview summarizes OAuth 2.0 flows that Google supports, which can help you to ensure that
      you've selected the right flow for your application.</aside>

    
    <p>This document explains how applications installed on devices like phones, tablets, and
      computers use Google's OAuth 2.0 endpoints to authorize access to
      Google APIs.</p>
    

    <p>OAuth 2.0 allows users to share specific data with an application while keeping their
      usernames, passwords, and other information private. 
For example, an application can use OAuth 2.0 to obtain permission from
users to store files in their Google Drives.
</p>

    <p>Installed apps are distributed to individual devices, and it is assumed that these apps
      cannot keep secrets. They can access Google APIs while the user is present at the app or when
      the app is running in the background.</p>

    <p>This authorization flow is similar to the one used for
      <a href="/identity/protocols/oauth2/web-server">web server applications</a>. The main difference is
      that installed apps must open the system browser and supply a local redirect URI to handle
      responses from Google's authorization server.</p>

    

    <p><b>Alternatives</b></p>

    <p>For mobile apps, you may prefer to use Google Sign-in for
      <a href="/identity/sign-in/android" title="Google Sign-in for Android">Android</a> or
      <a href="/identity/sign-in/ios" title="Google Sign-in for iOS">iOS</a>. The Google Sign-in
      client libraries handle authentication and user authorization, and they may be simpler to
      implement than the lower-level protocol described here.</p>

    <p>For apps running on devices that do not support a system browser or that have limited input
      capabilities, such as TVs, game consoles, cameras, or printers, see
      <a href="/identity/protocols/OAuth2ForDevices">OAuth 2.0 for TVs &amp; Devices</a> or
      <a href="/identity/sign-in/devices">Google Sign-in for devices</a>.</p>
    

    

    <h2 id="libraries">Libraries and samples</h2>

    <p>We recommend the following libraries and samples to help you implement the OAuth 2.0 flow
      described in this document:</p>

    <ul>
      <li><a href="https://openid.github.io/AppAuth-Android/">AppAuth for Android</a> library and
        <a href="https://codelabs.developers.google.com/codelabs/appauth-android-codelab/">
          codelab</a></li>
      <li><a href="https://openid.github.io/AppAuth-iOS/">AppAuth for iOS</a> library</li>
      <li><a href="https://github.com/googlesamples/oauth-apps-for-windows">OAuth for Apps: Windows
        Samples</a></li>
    </ul>
    

    

    <h2 id="prerequisites">Prerequisites</h2>

    
    




 













<h3 id="enable-apis">Enable APIs for your project</h3>

<p>Any application that calls Google APIs needs to enable those APIs in the
  API Console.</p>



<p>To enable an API for your project:</p>

<ol>
  <li><a href="https://console.developers.google.com/apis/library">Open the API Library</a> in the
    Google API Console.</li>
  <li>If prompted, select a project, or create a new one.</li>

  <li>The API Library lists all available APIs, grouped by product
    family and popularity. If the API you want to enable isn't visible in the list, use search to
    find it, or click <b>View All</b> in the product family it belongs to.</li>
  <li>Select the API you want to enable, then click the <b>Enable</b> button.</li>
  <li>If prompted, enable billing.</li>
  <li>If prompted, read and accept the API&#39;s Terms of Service.</li>

</ol>
    

    
    




 












    <h3 id="creatingcred">Create authorization credentials</h3>

<p>Any application that uses OAuth 2.0 to access Google APIs must have authorization credentials
  that identify the application to Google's OAuth 2.0 server. The following steps explain how to
  create credentials for your project. Your applications can then use the credentials to access APIs
  that you have enabled for that project.</p>



    <ol>
      <li>Go to the <a href="https://console.developers.google.com/apis/credentials">Credentials page</a>.</li>
      <li>Click <b>Create credentials > OAuth client ID</b>.</li>
      <li>The sections below describe the application types and the redirect methods that Google's
        authorization server supports. Choose the one that is recommended for your application and
        set the other fields in the form as appropriate.

        <ul>
  <li id="redirect-uri_custom-scheme">
    <p><b>Option 1: Custom URI scheme (Android, iOS, UWP)</b></p>

    <table class="responsive details">
      <tr>
        <td><b>Recommended usage</b></td>
        <td>Android apps, iOS apps, Universal Windows Platform (UWP) apps</td>
      </tr>
      <tr>
        <td><b>Form values</b></td>
        <td>Set the application type to <b>Android</b> for Android apps and to <b>iOS</b> otherwise.
          Also set the package name or bundle ID &ndash; the field that is present depends on the
          application type &ndash; to the custom URI scheme that you will use in the redirect
          (e.g. <var>com.example.app</var>). Additionally, you can use the reverse DNS notion of the
          client ID as the custom URI scheme (e.g. <var>com.googleusercontent.apps.123</var>).
          <p>For UWP apps, the scheme cannot be longer than 39 characters.</p></td>
      </tr>
    </table>

    <aside class="note"><b>Note:</b> See the <a href="#request-parameter-redirect_uri">
      <code translate="no" dir="ltr">redirect_uri</code></a> parameter definition for details about the format of the custom
      URI scheme value. In addition, the <a href="#libraries">libraries and samples</a> demonstrate
      some platform-specific implementations of custom URI scheme redirects.</aside>
  </li>



  <li id="redirect-uri_loopback">
    <p><b>Option 2: Loopback IP address (macOS, Linux, Windows desktop)</b></p>
    <p>To receive the authorization code using this URL, your application must be listening on the
      local web server. That is possible on many, but not all, platforms. However, if your platform
      supports it, this is the recommended mechanism for obtaining the authorization code.</p>
    <p>When your app receives the authorization response, for best usability it should respond by
      displaying an HTML page that instructs the user to close the browser and return to your
      app.</p>

    <table class="responsive details">
      <tr>
        <td><b>Recommended usage</b></td>
        <td>macOS, Linux, and Windows desktop (but not Universal Windows Platform) apps</td>
      </tr>
      <tr>
        <td><b>Form values</b></td>
        <td>Set the application type to <b>Other</b>.</td>
      </tr>
    </table>

    <aside class="note"><b>Note:</b> See the <a href="#request-parameter-redirect_uri">
      <code translate="no" dir="ltr"> redirect_uri</code></a> parameter definition for more information about the loopback IP
      address. It is also possible to use <code translate="no" dir="ltr">localhost</code> in place of the loopback IP, but
      this may cause issues with client firewalls. Most, but not all, firewalls allow loopback
      communication.</aside>
  </li>
  <li><b>Option 3: Manual copy/paste</b>
    <aside class="warning"><b>Important:</b> The <a href="#redirect-uri_custom-scheme">
      custom URI scheme</a> and <a href="#redirect-uri_loopback">loopback IP address</a> options now
      provide more reliable, secure, and user-friendly ways to obtain user authorization. This
      option may be discontinued in the future and should only be used if the choices above are not
      viable.</aside>

    <section class="expandable">

      <h4 id="redirect-uri_oob-manual" class="showalways">See manual copy/paste details</h4>

      <p>This redirect method returns the authorization code in the HTML page's
        <code translate="no" dir="ltr">&lt;title&gt;</code> field and also displays the code to the user, as shown in the
        image below. The user must then manually copy and paste the code into your application.</p>

      <div>
        <figure>
          <img src="/accounts/images/installedresult.png"
               alt="authorization code displayed to the user to copy to their clipboard">
        </figure>
      </div>

      <p>Traditionally, apps that used this option programmatically extracted the authorization code
        from the HTML page. The copy/paste option served as a fallback in case the value could not
        be parsed.</p>

      <table class="responsive details">
        <tr>
          <td><b>Recommended usage</b></td>
          <td>Platforms that cannot support an automatic browser redirect via a
            <a href="#redirect-uri_custom-scheme">custom URI scheme</a> or
            <a href="#redirect-uri_loopback">loopback IP address</a>. Note that in most cases where
            the platform does not have a usable browser, the
            <a href="/identity/protocols/oauth2/limited-input-device">OAuth 2.0 for TVs &amp; Devices</a> flow is
            recommended.</td>
        </tr>
        <tr>
          <td><b>Form values</b></td>
          <td>Set the application type to <b>Other</b>.</td>
        </tr>
      </table>
    </section>
  </li>
  <li><b>Option 4: Programmatic extraction</b>
    <aside class="warning"><b>Important:</b> This method is identical to the manual copy/paste
      method described above <i>except</i> the confirmation page does not instruct the user to copy
      the authorization code. Instead, the page just asks the user to close the window.
      <p>This option is
        <a href="https://developers.googleblog.com/2016/08/modernizing-oauth-interactions-in-native-apps.html">
          deprecated</a> for OAuth 2.0 to Google. It was designed for embedded browsers, or
        web-views. The <a href="#redirect-uri_custom-scheme">custom URI scheme</a> and
        <a href="#redirect-uri_loopback">loopback IP address</a> options now provide more reliable,
        secure, and user-friendly ways to obtain user authorization.</p></aside>

    <section class="expandable">

      <h4 id="redirect-uri_oob-manual" class="showalways">See programmatic extraction details</h4>

      <table class="responsive details">
        <tr>
          <td><b>Recommended usage</b></td>
          <td>Platforms that would use the manual copy/paste method but are unequivocally able to
            extract the authorization code from the redirect HTML page. In other words, you might
            use this method on a platform that does not support a
            <a href="#redirect-uri_custom-scheme">custom URI scheme</a> or
            <a href="#redirect-uri_loopback">loopback IP address</a> but does still enable the
            client to inspect the title of the redirect HTML page.</td>
        </tr>
        <tr>
          <td><b>Form values</b></td>
          <td>Set the application type to <b>Other</b>.</td>
        </tr>
      </table>
    </section>

</li>
</ul>
      </li>
    </ol>

     

    
    <h3 id="identify-access-scopes">Identify access scopes</h3>

<p>Scopes enable your application to only request access to the resources that it needs while also
  enabling users to control the amount of access that they grant to your application. Thus, there
  may be an inverse relationship between the number of scopes requested and the likelihood of
  obtaining user consent.</p>

<p>Before you start implementing OAuth 2.0 authorization, we recommend that you identify the scopes
  that your app will need permission to access.</p>




<aside class="note"><b>Note:</b> Incremental authorization is not supported for installed apps or
  devices.</aside>




<p>The <a href="/identity/protocols/googlescopes">OAuth 2.0 API Scopes</a> document contains a full
  list of scopes that you might use to access Google APIs.</p>

<aside class="warning">If your public application uses scopes that permit access to
  certain user data, it must complete a verification process. If you see <strong>unverified
  app</strong> on the screen when testing your application, you must submit a
  verification request to remove it. Find out more about
  <a href="https://support.google.com/cloud/answer/7454865">unverified apps</a>
  and get answers to <a href="https://support.google.com/cloud/answer/9110914">
  frequently asked questions about app verification</a> in the Help Center.
</aside>
     

     

    

    
    <h2 id="obtainingaccesstokens">Obtaining OAuth 2.0 access tokens</h2>

<p>The following steps show how your application interacts with Google's OAuth 2.0 server to obtain
  a user's consent to perform an API request on the user's behalf. Your application must have that
  consent before it can execute a Google API request that requires user authorization.</p>


    

    

    

    

    <h3 id="step1-code-verifier">Step 1: Generate a code verifier and challenge</h3>

    <p>Google supports the <a href="https://tools.ietf.org/html/rfc7636">Proof Key for Code Exchange</a>
  protocol to make the installed app flow more secure. A unique code verifier is created for every
  authorization request, and its transformed value, called "code_challenge", is sent to the
  authorization server to obtain the authorization code.</p>

<h4 id="create-code-challenge">Create the code verifier</h4>

<p>A <code translate="no" dir="ltr">code_verifier</code> is a high-entropy cryptographic random string using the unreserved
  characters [A-Z] / [a-z] / [0-9] / "-" / "." / "_" / "~", with a minimum length of 43 characters
  and a maximum length of 128 characters.</p>

<p>The code verifier should have enough entropy to make it impractical to guess the value.</p>

<h4>Create the code challenge</h4>

<p>Two methods of creating the code challenge are supported.</p>

<table class="responsive">
  <thead>
    <tr>
      <th colspan="2">Code Challenge Generation Methods</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td><b>plain</b></td>
      <td>The code challenge is the same value as the code verifier generated above.<br>
        <pre class="notranslate" dir="ltr">
<code translate="no" dir="ltr">code_challenge</code> = <code translate="no" dir="ltr">code_verifier</code></pre>
      </td>
    </tr>
    <tr>
      <td><b>S256</b></td>
      <td>The code challenge is the Base64URL (with no padding) encoded SHA256 hash of the code
        verifier.<br>
        <pre class="notranslate" dir="ltr">
<code translate="no" dir="ltr">code_challenge</code> = BASE64URL-ENCODE(SHA256(ASCII(<code translate="no" dir="ltr">code_verifier</code>)))</pre>
      </td>
    </tr>
  </tbody>
</table>

    <h3>Step 2: Send a request to Google's OAuth 2.0 server</h3>

    <p>To obtain user authorization, send a request to Google's authorization server at
  <code translate="no" dir="ltr">https://accounts.google.com/o/oauth2/v2/auth</code>. This endpoint handles active session lookup, authenticates the
  user, and obtains user consent. The endpoint is only accessible over SSL, and it refuses HTTP
  (non-SSL) connections.</p>

<p>The authorization server supports the following query string parameters for installed
  applications:</p>

<table class="responsive details">
  <thead>
    <tr>
      <th colspan="2">Parameters</th>
    </tr>
  </thead>
  <tbody>
    <tr id="request-parameter-client_id">
      <td><code translate="no" dir="ltr">client_id</code></td>
      <td><strong>Required</strong>
        <p>The client ID for your application. You can find this value in the
          API Console <a href="https://console.developers.google.com/apis/credentials">Credentials page</a>.</p>
        
      </td>
    </tr>

    
    <tr id="request-parameter-redirect_uri">
      <td><code translate="no" dir="ltr">redirect_uri</code></td>
      <td><strong>Required</strong>
        
          <p>Determines how Google's authorization server sends a response to your app. There are
            several redirect options available to installed apps, and you will have set up your
            <a href="#creatingcred">authorization credentials</a> with a particular redirect method
            in mind.</p>
          <p>The value must exactly match one of the authorized redirect redirect URIs for the OAuth
            2.0 client, which you configured in your client's API Console
            <a href="https://console.developers.google.com/apis/credentials">Credentials page</a>. If this value doesn't match an authorized URI, you will get
            a <code translate="no" dir="ltr">redirect_uri_mismatch</code> error.</p>
          <p>The table below shows the appropriate <code translate="no" dir="ltr">redirect_uri</code> parameter value for
            each method:</p>
          <table class="responsive">
            <thead>
              <tr>
                <th colspan="2"><code translate="no" dir="ltr">redirect_uri</code> values</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <td><strong>Custom URI scheme</strong></td>
                <td><code translate="no" dir="ltr"><var>com.example.app</var>:<var>redirect_uri_path</var></code>
                  <p>or</p>
                  <code translate="no" dir="ltr"><var>com.googleusercontent.apps.123</var>:<var>redirect_uri_path</var>
                  </code>
                  <ul>
                    <li><var>com.example.app</var> is the reverse DNS notation of a domain under
                      your control. The custom scheme must contain a period to be valid.</li>
                    <li><var>com.googleusercontent.apps.123</var> is the reverse DNS notation of the
                      client ID.</li>
                    <li><var>redirect_uri_path</var> is an optional path component, such as
                      <code translate="no" dir="ltr">/oauth2redirect</code>. Note that the path should begin with a single
                      slash, which is different from regular HTTP URLs.</li>
                  </ul>
                </td>
              </tr>
              <tr>
                <td><strong>Loopback IP address</strong></td>
                <td><code translate="no" dir="ltr">http://127.0.0.1:<var>port</var></code> or
                  <code translate="no" dir="ltr">http://[::1]:<var>port</var></code>
                  <p>Query your platform for the relevant loopback IP address and start an HTTP
                    listener on a random available port. Substitute <var>port</var> with the actual
                    port number your app listens on.</p></td>
              </tr>
              <tr>
                <td><strong>Manual copy/paste</strong></td>
                <td><code translate="no" dir="ltr">urn:ietf:wg:oauth:2.0:oob</code></td>
              </tr>
              <tr>
                <td><strong>Programmatic extraction</strong></td>
                <td><code translate="no" dir="ltr">urn:ietf:wg:oauth:2.0:oob:auto</code></td>
              </tr>
          </table>
        
      </td>
    </tr>

    

    
      
      <tr id="request-parameter-response_type">
        <td><code translate="no" dir="ltr">response_type</code></td>
        <td><strong>Required</strong>
        
        <p>Determines whether the Google OAuth 2.0 endpoint returns an authorization code.</p>
          
          <p>Set the parameter value to <code translate="no" dir="ltr">code</code> for installed applications.</p>
          
        
        </td>
      </tr>
      
    

    <tr id="request-parameter-scope">
      <td id="scope"><code translate="no" dir="ltr">scope</code></td>
      <td><strong>Required</strong>
        <p>A
          space-delimited
          list of scopes that identify the resources that your application could access on the
          user's behalf. These values inform the consent screen that Google displays to the
          user.</p>

        <p>Scopes enable your application to only request access to the resources that it needs
          while also enabling users to control the amount of access that they grant to your
          application. Thus, there is an inverse relationship between the number of scopes requested
          and the likelihood of obtaining user consent.</p>
        
        
        
      </td>
    </tr>

    

    
    <tr id="request-parameter-code-challenge">
      <td><code translate="no" dir="ltr">code_challenge</code></td>
      <td><strong>Recommended</strong>
        <p>Specifies an encoded <code translate="no" dir="ltr">code_verifier</code> that will be used as a server-side
          challenge during authorization code exchange. This parameter must be used
          with the <code translate="no" dir="ltr">code_challenge</code> parameter described above. See
          <a href="/identity/protocols/oauth2/native-app#create-code-challenge">create code
            challenge</a> section above for more information.</p></td>
    </tr>
    

    
    <tr id="request-parameter-code-challenge-method">
      <td><code translate="no" dir="ltr">code_challenge_method</code></td>
      <td><strong>Recommended</strong>
        <p>Specifies what method was used to encode a <code translate="no" dir="ltr">code_verifier</code> that will be used
          during authorization code exchange. This parameter must be used with the
          <code translate="no" dir="ltr">code_challenge</code> parameter. The value of the <code translate="no" dir="ltr">code_challenge_method</code>
          defaults to <code translate="no" dir="ltr">plain</code> if not present in the request that includes a
          <code translate="no" dir="ltr">code_challenge</code>. The only supported values for this parameter are
          <code translate="no" dir="ltr">S256</code> or <code translate="no" dir="ltr">plain</code>.</td>
    </tr>
    

    
    <tr id="request-parameter-state">
      <td><code translate="no" dir="ltr">state</code></td>
      <td><strong>Recommended</strong>
        <p>Specifies any string value that your application uses to maintain state between your
          authorization request and the authorization server's response. The server returns the
          exact value that you send as a <code translate="no" dir="ltr">name=value</code> pair in the
          URL fragment identifier (<code translate="no" dir="ltr">#</code>) of the <code translate="no" dir="ltr">redirect_uri</code> after the user
          consents to or denies your application's access request.</p>
        <p>You can use this parameter for several purposes, such as directing the user to the
          correct resource in your application, sending nonces, and mitigating cross-site request
          forgery. Since your <code translate="no" dir="ltr">redirect_uri</code> can be guessed, using a <code translate="no" dir="ltr">state</code>
          value can increase your assurance that an incoming connection is the result of an
          authentication request. If you generate a random string or encode the hash of a cookie or
          another value that captures the client's state, you can validate the response to
          additionally ensure that the request and response originated in the same browser,
          providing protection against attacks such as cross-site request forgery. See the
          <a href="/identity/protocols/OpenIDConnect#createxsrftoken">OpenID Connect</a>
          documentation for an example of how to create and confirm a <code translate="no" dir="ltr">state</code> token.</p>
        
        
      </td>
    </tr>
    

    

    
    <tr id="request-parameter-login_hint">
      <td><code translate="no" dir="ltr">login_hint</code></td>
      <td><strong>Optional</strong>
        <p>If your application knows which user is trying to authenticate, it can use this parameter
          to provide a hint to the Google Authentication Server. The server uses the hint to
          simplify the login flow either by prefilling the email field in the sign-in form or by
          selecting the appropriate multi-login session.</p>
        <p>Set the parameter value to an email address or <code translate="no" dir="ltr">sub</code> identifier, which is
          equivalent to the user's Google ID.</p>
        
      </td>
    </tr>
    

    

    
  </tbody>
</table>


<aside class="note"><b>Note:</b> incremental authorization with installed apps is not supported due
  to the fact that the client cannot keep the <code translate="no" dir="ltr">client_secret</code> confidential.</aside>


<h4>Sample authorization URLs</h4>

<p>The tabs below show sample authorization URLs for the different redirect URI options.</p>



<p>The URLs are identical except for the value of the <code translate="no" dir="ltr">redirect_uri</code> parameter. The URLs
  also contain the required <code translate="no" dir="ltr">response_type</code> and <code translate="no" dir="ltr">client_id</code> parameters as well
  as the optional <code translate="no" dir="ltr">state</code> parameter. Each URL contains line breaks and spaces for
  readability.</p>

<div class="ds-selector-dropdown" data-ds-scope="lang">
  <section>

    <h3 class="hide-from-toc">Custom URI scheme</h3>

    
    <pre translate="no" dir="ltr">https://accounts.google.com/o/oauth2/v2/auth?
 scope=email%20profile&amp;
 response_type=code&amp;
 state=security_token%3D138r5719ru3e1%26url%3Dhttps%3A%2F%2Foauth2.example.com%2Ftoken&amp;
 redirect_uri=<strong>com.example.app%3A/oauth2redirect</strong>&amp;
 client_id=<var>client_id</var></pre>

  </section>

  <section>

    <h3 class="hide-from-toc">Loopback IP address</h3>

    
    <pre translate="no" dir="ltr">https://accounts.google.com/o/oauth2/v2/auth?
 scope=email%20profile&amp;
 response_type=code&amp;
 state=security_token%3D138r5719ru3e1%26url%3Dhttps%3A%2F%2Foauth2.example.com%2Ftoken&amp;
 redirect_uri=<strong>http%3A//127.0.0.1%3A9004</strong>&amp;
 client_id=<var>client_id</var></pre>

  </section>

  <section>

    <h3 class="hide-from-toc">Copy/Paste</h3>

    <aside class="warning"><b>Important:</b> This redirect URI option uses practices that may be
      less secure or user-friendly than other options.</aside>

    
    <pre translate="no" dir="ltr">https://accounts.google.com/o/oauth2/v2/auth?
 scope=email%20profile&amp;
 response_type=code&amp;
 state=security_token%3D138r5719ru3e1%26url%3Dhttps%3A%2F%2Foauth2.example.com%2Ftoken&amp;
 redirect_uri=<strong>urn%3Aietf%3Awg%3Aoauth%3A2.0%3Aoob</strong>&amp;
 client_id=<var>client_id</var></pre>

  </section>

  <section>

    <h3 class="hide-from-toc">Programmatic extraction</h3>

    <aside class="warning"><b>Important:</b> This redirect URI option, which is designed for
      embedded browsers, is deprecated. Like the copy/paste option, it uses practices that may be
      less secure or user-friendly than other options.</aside>

    
    <pre translate="no" dir="ltr">https://accounts.google.com/o/oauth2/v2/auth?
 scope=email%20profile&amp;
 response_type=code&amp;
 state=security_token%3D138r5719ru3e1%26url%3Dhttps%3A%2F%2Foauth2.example.com%2Ftoken&amp;
 redirect_uri=<strong>urn%3Aietf%3Awg%3Aoauth%3A2.0%3Aoob%3Aauto</strong>&amp;
 client_id=<var>client_id</var></pre>

  </section>

</div>

    

     

    

    <h3 id="handlingresponse">Step 3: Google prompts user for consent</h3>

    <p>In this step, the user decides whether to grant your application the requested access. At this
  stage, Google displays a consent window that shows the name of your application and the Google API
  services that it is requesting permission to access with the user's authorization credentials and
  a summary of the scopes of access to be granted. The
  user can then consent to grant access to one or more scopes requested by your application or
  refuse the request.</p>

<p>Your application doesn't need to do anything at this stage as it waits for the response from
  Google's OAuth 2.0 server indicating whether any access was granted. That response is explained in
  the following step.</p>

     

    
    

    <h3 id="handlingresponse">Step 4: Handle the OAuth 2.0 server response</h3>

    <p>The manner in which your application receives the authorization response depends on the
      <a href="#creatingcred">redirect URI scheme</a> that it uses. Regardless of the scheme, the
      response will either contain an authorization code (<code translate="no" dir="ltr">code</code>) or an error
      (<code translate="no" dir="ltr">error</code>). For example, <code translate="no" dir="ltr">error=access_denied</code> indicates that the user
      declined the request.</p>

    <p>If the user grants access to your application, you can exchange the authorization code for an
      access token and a refresh token as described in the next step.</p>

     

    <h3 id="exchange-authorization-code">Step 5: Exchange authorization code for refresh and access
      tokens</h3>

    
    

    

    








<p>To exchange an authorization code for an access token, call the
  <code translate="no" dir="ltr">https://oauth2.googleapis.com/token</code> endpoint and set the following parameters:</p>

<table class="responsive">
  <thead>
    <tr>
      <th colspan="2">Fields</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td><code translate="no" dir="ltr">client_id</code></td>
      <td>The client ID obtained from the API Console <a href="https://console.developers.google.com/apis/credentials">Credentials page</a>.</td>
    </tr>

    <tr>
      <td><code translate="no" dir="ltr">client_secret</code></td>
      <td>The client secret obtained from the API Console
        <a href="https://console.developers.google.com/apis/credentials">Credentials page</a>.</td>
    </tr>

    <tr>
      <td><code translate="no" dir="ltr">code</code></td>
      <td>The authorization code returned from the initial request.</td>
    </tr>

    
    <tr>
      <td><code translate="no" dir="ltr">code_verifier</code></td>
      <td>The code verifier you created in
        <a href="/identity/protocols/oauth2/native-app#step1-code-verifier">Step 1</a>.</td>
    </tr>
    

    <tr>
      <td><code translate="no" dir="ltr">grant_type</code></td>
      <td><a href="https://tools.ietf.org/html/rfc6749#section-4.1.3">As defined in the OAuth 2.0
        specification</a>, this field must contain a value of <code translate="no" dir="ltr">authorization_code</code>.</td>
    </tr>
    <tr>
      <td><code translate="no" dir="ltr">redirect_uri</code></td>
      <td>One of the redirect URIs listed for your project in the API Console
        <a href="https://console.developers.google.com/apis/credentials">Credentials page</a> for the given <code translate="no" dir="ltr">client_id</code>.</td>
    </tr>
  </tbody>
</table>

<p>The following snippet shows a sample request:</p>

<pre class="notranslate" dir="ltr">POST /token HTTP/1.1
Host: oauth2.googleapis.com
Content-Type: application/x-www-form-urlencoded

code=4/P7q7W91a-oMsCeLvIaQm6bTrgtp7&amp;
client_id=<var class="apiparam">your_client_id</var>&amp;
client_secret=<var class="apiparam">your_client_secret</var>&amp;
redirect_uri=urn%3Aietf%3Awg%3Aoauth%3A2.0%3Aoob%3Aauto&amp;
grant_type=authorization_code</pre>

<p>Google responds to this request by returning a JSON object that contains a short-lived access
  token and a refresh token.

</p>

<p>The response contains the following fields:</p>

<table class="responsive details">
  <thead>
    <tr>
      <th colspan="2">Fields</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td><code translate="no" dir="ltr">access_token</code></td>
      <td>The token that your application sends to authorize a Google API request.</td>
    </tr>
    <tr>
      <td><code translate="no" dir="ltr">expires_in</code></td>
      <td>The remaining lifetime of the access token in seconds.</td>
    </tr>

    
    <tr>
      <td><code translate="no" dir="ltr">id_token</code></td>
      <td><b>Note:</b> This property is only returned if your request included an identity scope,
        such as <code translate="no" dir="ltr">openid</code>, <code translate="no" dir="ltr">profile</code>, or <code translate="no" dir="ltr">email</code>. The value is a
        JSON Web Token (JWT) that contains digitally signed identity information about the
        user.</td>
    </tr>
    
    <tr>
      <td><code translate="no" dir="ltr">refresh_token</code></td>
      <td>A token that you can use to obtain a new access token. Refresh tokens are valid until the
        user revokes access.
    
        Note that refresh tokens are always returned for installed applications.
    
      </td>
    </tr>
    <tr>
      <td><code translate="no" dir="ltr">scope</code></td>
      <td>The scopes of access granted by the <code translate="no" dir="ltr">access_token</code> expressed as a list of
        space-delimited, case-sensitive strings.</td>
    </tr>
    <tr>
      <td><code translate="no" dir="ltr">token_type</code></td>
      <td>The type of token returned. At this time, this field's value is always set to
        <code translate="no" dir="ltr">Bearer</code>.</td>
    </tr>
  </tbody>
</table>

<aside class="key-point"><b>Important:</b> Your application should store both tokens in a secure,
  long-lived location that is accessible between different invocations of your application. The
  refresh token enables your application to obtain a new access token if the one that you have
  expires. As such, if your application loses the refresh token, the user will need to repeat the
  OAuth 2.0 consent flow so that your application can obtain a new refresh token.</aside>



<p>The following snippet shows a sample response:</p>

<pre class="prettyprint lang-js" translate="no" dir="ltr">
{
  "access_token": "1/fFAGRNJru1FTz70BzhT3Zg",
  "expires_in": 3920,
  "token_type": "Bearer",
  "scope": "https://www.googleapis.com/auth/drive.metadata.readonly",
  "refresh_token": "1//xEoDL4iW3cxlI7yDbSRFYNG01kVKM2C-259HOF2aQbI"
}</pre>

<aside class="note"><b>Note:</b> Your application should ignore any unrecognized fields included in
  the response.</aside>

    
     

    


    

    <h2 id="callinganapi">Calling Google APIs</h2>

    
     
    























<p>After your application obtains an access token, you can use the token to make calls to a Google
  API on behalf of a given
  user account if the scope(s) of access required by the API have been granted. To do this, include
  the access token in a request to the API by including either an <code translate="no" dir="ltr">access_token</code> query
  parameter or an <code translate="no" dir="ltr">Authorization</code> HTTP header <code translate="no" dir="ltr">Bearer</code> value. When possible,
  the HTTP header is preferable, because query strings tend to be visible in server logs. In most
  cases you can use a client library to set up your calls to Google APIs (for example, when
  <a href="/drive/api/v2/reference#Files">calling the Drive Files API</a>).</p>



<p>You can try out all the Google APIs and view their scopes at the
  <a href="https://developers.google.com/oauthplayground/">OAuth 2.0 Playground</a>.</p>

<h4>HTTP GET examples</h4>

<p>A call to the
  <a href="/drive/v2/reference/files/list">
    <code translate="no" dir="ltr">drive.files</code></a>
  endpoint (the Drive Files API) using the <code translate="no" dir="ltr">Authorization: Bearer</code> HTTP
  header might look like the following. Note that you need to specify your own access token:<p>

<pre translate="no" dir="ltr">
GET /drive/v2/files HTTP/1.1
Host: www.googleapis.com
<strong>Authorization: Bearer <var>access_token</var></strong></pre>

<p>Here is a call to the same API for the authenticated user using the <code translate="no" dir="ltr">access_token</code>
  query string parameter:</p>

<pre translate="no" dir="ltr">
GET https://www.googleapis.com/drive/v2/files?access_token=<var>access_token</var></pre>

<h4><code translate="no" dir="ltr">curl</code> examples</h4>

<p>You can test these commands with the <code translate="no" dir="ltr">curl</code> command-line application. Here's an
  example that uses the HTTP header option (preferred):</p>

<pre class="devsite-terminal" translate="no" dir="ltr">
curl -H "Authorization: Bearer <var>access_token</var>" https://www.googleapis.com/drive/v2/files</pre>

<p>Or, alternatively, the query string parameter option:</p>

<pre class="devsite-terminal" translate="no" dir="ltr">
curl https://www.googleapis.com/drive/v2/files?access_token=<var>access_token</var></pre>
     

     
     

    

    <h2 id="offline">Refreshing an access token</h2>

    

<p>Access tokens periodically expire and become invalid credentials for a related API request. You
  can refresh an access token without prompting the user for permission (including when the user is
  not present) if you requested offline access to the scopes associated with the token.</p>

    
     
    














































































































































































<p>To refresh an access token, your application sends an HTTPS <code class="notranslate" dir="ltr">POST</code>
  request to Google's authorization server (<code translate="no" dir="ltr">https://oauth2.googleapis.com/token</code>) that
  includes the following parameters:

<table class="responsive">
  <thead>
    <tr>
      <th colspan="2">Fields</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td><code translate="no" dir="ltr">client_id</code></td>
      <td>The client ID obtained from the <a href="https://console.developers.google.com/">API Console</a>.</td>
    </tr>
    <tr>
      <td><code translate="no" dir="ltr">client_secret</code></td>
      <td>The client secret obtained from the <a href="https://console.developers.google.com/">API Console</a>.
        
        (The <code translate="no" dir="ltr">client_secret</code> is not applicable to requests from clients registered as
        Android, iOS, or Chrome applications.)
        
      </td>
    </tr>
    <tr>
      <td><code translate="no" dir="ltr">grant_type</code></td>
      <td>As
        <a href="https://tools.ietf.org/html/rfc6749#section-6" class="external">defined in the
          OAuth 2.0 specification</a>,
        this field must contain a value of <code translate="no" dir="ltr">refresh_token</code>.</td>
    </tr>
    <tr>
      <td><code translate="no" dir="ltr">refresh_token</code></td>
      <td>The refresh token returned from the authorization code exchange.</td>
    </tr>
  </tbody>
</table>

<p>The following snippet shows a sample request:</p>

<pre class="notranslate" dir="ltr">
POST /token HTTP/1.1
Host: oauth2.googleapis.com
Content-Type: application/x-www-form-urlencoded

client_id=<var>your_client_id</var>&amp;
client_secret=<var>your_client_secret</var>&amp;
refresh_token=<var>refresh_token</var>&amp;
grant_type=refresh_token</pre>

<p>As long as the user has not revoked the access granted to the application, the token server
  returns a JSON object that contains a new access token. The following snippet shows a sample
  response:</p>

<pre class="prettyprint lang-js notranslate" dir="ltr">
{
  "access_token": "1/fFAGRNJru1FTz70BzhT3Zg",
  "expires_in": 3920,
  "scope": "https://www.googleapis.com/auth/drive.metadata.readonly",
  "token_type": "Bearer"
}</pre>

<p>Note that there are limits on the number of refresh tokens that will be issued; one limit per
  client/user combination, and another per user across all clients. You should save refresh tokens
  in long-term storage and continue to use them as long as they remain valid. If your application
  requests too many refresh tokens, it may run into these limits, in which case older refresh tokens
  will stop working.</p>
    

    

    <h2 id="tokenrevoke">Revoking a token</h2>

<p>In some cases a user may wish to revoke access given to an application. A user can revoke access
  by visiting <a href="https://myaccount.google.com/permissions" class="external">
  Account Settings</a>. See the
  <a href="https://support.google.com/accounts/answer/3466521#remove-access" class="external">Remove
    site or app access section of the Third-party sites &amp; apps with access to your account</a>
  support document for more information.</p>

<p>It is also possible for an application to programmatically revoke the access given to it.
  Programmatic revocation is important in instances where a user unsubscribes, removes an
  application, or the API resources required by an app have significantly changed. In other words,
  part of the removal process can include an API request to ensure the permissions previously
  granted to the application are removed.</p>

    

    
    











<p>To programmatically revoke a token, your application makes a request to
<code translate="no" dir="ltr">https://oauth2.googleapis.com/revoke</code> and includes the token as a parameter:</p>

<pre class="devsite-terminal" translate="no" dir="ltr">
curl -H "Content-type:application/x-www-form-urlencoded" \
        https://oauth2.googleapis.com/revoke?token=<var>{token}</var></pre>

<p>The token can be an access token or a refresh token. If the token is an access token and it has a
  corresponding refresh token, the refresh token will also be revoked.</p>



<p>If the revocation is successfully processed, then the HTTP status code of the response is
  <code translate="no" dir="ltr">200</code>. For error conditions, an HTTP status code <code translate="no" dir="ltr">400</code> is returned along
  with an error code.</p>


    

    

    <aside class="note"><b>Note:</b> Following a successful revocation response, it might take some
  time before the revocation has full effect.</aside>

    

    

    <h2 id="further_reading">Further Reading</h2>

    <p>The IETF Best Current Practice <a href="https://tools.ietf.org/html/rfc8252">OAuth 2.0 for
      Native Apps</a> establishes many of the best practices documented here.</p>
    

  
          </div>

    
                   <devsite-page-rating position="footer" selected-rating="0" hover-rating-star="0">
         </devsite-page-rating>
                   
          </article>
</article>

<devsite-content-footer class="nocontent">
  <p>Except as otherwise noted, the content of this page is licensed under the <a href="https://creativecommons.org/licenses/by/4.0/">Creative Commons Attribution 4.0 License</a>, and code samples are licensed under the <a href="https://www.apache.org/licenses/LICENSE-2.0">Apache 2.0 License</a>. For details, see the <a href="https://developers.google.com/site-policies">Google Developers Site Policies</a>. Java is a registered trademark of Oracle and/or its affiliates.</p>  <p>Last updated 2020-03-23.</p></devsite-content-footer>



                      </devsite-content>
        </main>
        <devsite-footer-promos class="devsite-footer">
                      
                  </devsite-footer-promos>
        <devsite-footer-linkboxes class="devsite-footer">
                      <nav class="devsite-footer-linkboxes nocontent">
    <ul class="devsite-footer-linkboxes-list">
        <li class="devsite-footer-linkbox ">
    <h3 class="devsite-footer-linkbox-heading">Product Info</h3>      <ul class="devsite-footer-linkbox-list">
                <li class="devsite-footer-linkbox-item">
          <a href="/terms"
             class="devsite-footer-linkbox-link
                    gc-analytics-event"
             data-category="Site-Wide Custom Events"
                        data-label="Footer Link (index 1)"           >
            Terms of Service
          </a>
        </li>
                <li class="devsite-footer-linkbox-item">
          <a href="/terms/api-services-user-data-policy"
             class="devsite-footer-linkbox-link
                    gc-analytics-event"
             data-category="Site-Wide Custom Events"
                        data-label="Footer Link (index 2)"           >
            APIs User Data Policy
          </a>
        </li>
                <li class="devsite-footer-linkbox-item">
          <a href="/identity/branding-guidelines"
             class="devsite-footer-linkbox-link
                    gc-analytics-event"
             data-category="Site-Wide Custom Events"
                        data-label="Footer Link (index 3)"           >
            Branding Guidelines
          </a>
        </li>
              </ul>
    </li>
        <li class="devsite-footer-linkbox ">
    <h3 class="devsite-footer-linkbox-heading">Connect</h3>      <ul class="devsite-footer-linkbox-list">
                <li class="devsite-footer-linkbox-item">
          <a href="//groups.google.com/forum/#!forum/google-federated-login-api"
             class="devsite-footer-linkbox-link
                    gc-analytics-event"
             data-category="Site-Wide Custom Events"
                        data-label="Footer Link (index 1)"           >
            Google Federated Login API Forum
          </a>
        </li>
              </ul>
    </li>
        <li class="devsite-footer-linkbox ">
    <h3 class="devsite-footer-linkbox-heading">StackOverflow</h3>      <ul class="devsite-footer-linkbox-list">
                <li class="devsite-footer-linkbox-item">
          <a href="//stackoverflow.com/questions/tagged/google-identity"
             class="devsite-footer-linkbox-link
                    gc-analytics-event"
             data-category="Site-Wide Custom Events"
                        data-label="Footer Link (index 1)"           >
            Google Identity solutions
          </a>
        </li>
                <li class="devsite-footer-linkbox-item">
          <a href="//stackoverflow.com/questions/tagged/google-oauth"
             class="devsite-footer-linkbox-link
                    gc-analytics-event"
             data-category="Site-Wide Custom Events"
                        data-label="Footer Link (index 2)"           >
            Google OAuth 2.0 and OpenID Connect
          </a>
        </li>
              </ul>
    </li>
      </ul>
  </nav>
                  </devsite-footer-linkboxes>
        <devsite-footer-utility class="devsite-footer">
                      
<div class="devsite-footer-utility nocontent">
    <nav class="devsite-footer-sites">
    <a href="https://developers.google.com/"
       class="devsite-footer-sites-logo-link gc-analytics-event"
       data-category="Site-Wide Custom Events"
       data-label="Footer Google Developers Link">
      <img class="devsite-footer-sites-logo"
           src="/_static/images/lockup-developers.svg"
           alt="Google Developers">
    </a>
    <ul class="devsite-footer-sites-list">
            <li class="devsite-footer-sites-item">
        <a href="//developer.android.com"
           class="devsite-footer-sites-link
                  gc-analytics-event"
           data-category="Site-Wide Custom Events"
                    data-label="Footer Android Link"
                  >
          Android
        </a>
      </li>
            <li class="devsite-footer-sites-item">
        <a href="//developer.chrome.com/home"
           class="devsite-footer-sites-link
                  gc-analytics-event"
           data-category="Site-Wide Custom Events"
                    data-label="Footer Chrome Link"
                  >
          Chrome
        </a>
      </li>
            <li class="devsite-footer-sites-item">
        <a href="//firebase.google.com"
           class="devsite-footer-sites-link
                  gc-analytics-event"
           data-category="Site-Wide Custom Events"
                    data-label="Footer Firebase Link"
                  >
          Firebase
        </a>
      </li>
            <li class="devsite-footer-sites-item">
        <a href="//cloud.google.com"
           class="devsite-footer-sites-link
                  gc-analytics-event"
           data-category="Site-Wide Custom Events"
                    data-label="Footer Google Cloud Platform Link"
                  >
          Google Cloud Platform
        </a>
      </li>
            <li class="devsite-footer-sites-item">
        <a href="/products"
           class="devsite-footer-sites-link
                  gc-analytics-event"
           data-category="Site-Wide Custom Events"
                    data-label="Footer All products Link"
                  >
          Alla produkter
        </a>
      </li>
          </ul>
  </nav>
  
  <nav class="devsite-footer-utility-links">
        <ul class="devsite-footer-utility-list">
            <li class="devsite-footer-utility-item
                 ">
                        <a class="devsite-footer-utility-link gc-analytics-event"
           href="/terms/site-terms"
           data-category="Site-Wide Custom Events"
           data-label="Footer Terms link"
         >
          Villkor
        </a>
              </li>
            <li class="devsite-footer-utility-item
                 ">
                        <a class="devsite-footer-utility-link gc-analytics-event"
           href="//policies.google.com/privacy"
           data-category="Site-Wide Custom Events"
           data-label="Footer Privacy link"
         >
          Sekretess
        </a>
              </li>
            <li class="devsite-footer-utility-item
                 devsite-footer-utility-button">
                <span class="devsite-footer-utility-description">Registrera dig och få Google Developers nyhetsbrev</span>
                        <a class="devsite-footer-utility-link gc-analytics-event"
           href="//services.google.com/fb/forms/googledevelopersnewsletter/?utm_medium=referral&amp;utm_source=google-products&amp;utm_team=googledevs&amp;utm_campaign=201611-newsletter-launch"
           data-category="Site-Wide Custom Events"
           data-label="Footer Subscribe link"
         >
          Prenumerera
        </a>
              </li>
          </ul>
    
    <devsite-language-selector>
  <devsite-select class="devsite-language-selector-menu">
    <select class="devsite-language-selector-select"
            name="language"
            track-name="click"
            track-type="languageSelector">
                <option>Language</option>
              <option value="id"
              track-metadata-original-language="sv"
              track-metadata-selected-language="id"
              track-name="changed"
              track-type="languageSelector"
            >
        Bahasa Indonesia
      </option>
          <option value="de"
              track-metadata-original-language="sv"
              track-metadata-selected-language="de"
              track-name="changed"
              track-type="languageSelector"
            >
        Deutsch
      </option>
          <option value="en"
              track-metadata-original-language="sv"
              track-metadata-selected-language="en"
              track-name="changed"
              track-type="languageSelector"
            >
        English
      </option>
          <option value="es"
              track-metadata-original-language="sv"
              track-metadata-selected-language="es"
              track-name="changed"
              track-type="languageSelector"
            >
        Español
      </option>
          <option value="fr"
              track-metadata-original-language="sv"
              track-metadata-selected-language="fr"
              track-name="changed"
              track-type="languageSelector"
            >
        Français
      </option>
          <option value="pt_br"
              track-metadata-original-language="sv"
              track-metadata-selected-language="pt_br"
              track-name="changed"
              track-type="languageSelector"
            >
        Português – Brasil
      </option>
          <option value="sv"
              track-metadata-original-language="sv"
              track-metadata-selected-language="sv"
              track-name="changed"
              track-type="languageSelector"
            >
        Svenska
      </option>
          <option value="ru"
              track-metadata-original-language="sv"
              track-metadata-selected-language="ru"
              track-name="changed"
              track-type="languageSelector"
            >
        Русский
      </option>
          <option value="zh_cn"
              track-metadata-original-language="sv"
              track-metadata-selected-language="zh_cn"
              track-name="changed"
              track-type="languageSelector"
            >
        中文 – 简体
      </option>
          <option value="ja"
              track-metadata-original-language="sv"
              track-metadata-selected-language="ja"
              track-name="changed"
              track-type="languageSelector"
            >
        日本語
      </option>
          <option value="ko"
              track-metadata-original-language="sv"
              track-metadata-selected-language="ko"
              track-name="changed"
              track-type="languageSelector"
            >
        한국어
      </option>
        </select>
  </devsite-select>
</devsite-language-selector>

  </nav>
</div>
                  </devsite-footer-utility>
      </section></section>
    <devsite-sitemask></devsite-sitemask>
    <devsite-snackbar                   ></devsite-snackbar>    <devsite-tooltip ></devsite-tooltip>
    <devsite-heading-link></devsite-heading-link>
    <devsite-analytics>
              <script type="application/json" analytics>[{"metrics": {"ratings_value": "metric1", "ratings_count": "metric2"}, "dimensions": {"dimension6": "en", "dimension4": "Google Identity Platform", "dimension5": "sv", "dimension3": false, "dimension1": "Signed out", "dimension8": null}, "gaid": "UA-24532603-1"}]</script>
<script type="application/json" gtm>{}</script>
          </devsite-analytics>
        <script>
    (function(d,e,v,s,i,t,E){d['GoogleDevelopersObject']=i;
    t=e.createElement(v);t.async=1;t.src=s;E=e.getElementsByTagName(v)[0];
    E.parentNode.insertBefore(t,E);})(window, document, 'script',
    'https://www.gstatic.com/devrel-devsite/prod/v84899ba5ac366dd19b845bb4579ea9262ac5ac73d5db61a8fa440a5f2fc65a26/js/app_loader.js', '[1,"sv",null,"/js/devsite_app.js","https://www.gstatic.com/devrel-devsite/prod/v84899ba5ac366dd19b845bb4579ea9262ac5ac73d5db61a8fa440a5f2fc65a26","https://www.gstatic.com/devrel-devsite/prod/v84899ba5ac366dd19b845bb4579ea9262ac5ac73d5db61a8fa440a5f2fc65a26/developers","https://developers-dot-devsite-v2-prod.appspot.com",null,null,["/_pwa/developers/manifest.json","/_static/images/video-placeholder.svg","https://www.gstatic.com/devrel-devsite/prod/v84899ba5ac366dd19b845bb4579ea9262ac5ac73d5db61a8fa440a5f2fc65a26/developers/images/favicon.png","https://fonts.googleapis.com/css?family=Google+Sans:400,500|Roboto:400,400italic,500,500italic,700,700italic|Roboto+Mono:400,500,700|Material+Icons"],1]')
  </script>  </body>
</html>